/*
 * sflib.h --- SFLib syscall library for MacOS/PowerPC 
 * see http://www.secdev.org/projects/shellforge.html for more informations
 *
 * Copyright (C) 2004  Philippe Biondi <phil@secdev.org>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */


/*
 * Automatically generated by gensflib.py 
 * Sun Dec  5 01:07:50 2004
 */

#ifndef SFLIB_H
#define SFLIB_H


#include "sfsysnr.h"
#include "sfsyscall.h"
#include "../common/sftypes.h"
        
// syscall
static inline _sfsyscall1(int, exit, int, status)
static inline _sfsyscall0( pid_t, fork )
static inline _sfsyscall3( ssize_t, read, int, fd, void *, buf, size_t, count )
static inline _sfsyscall3( ssize_t, write, int, fd, const void *, buf, size_t, count )
static inline _sfsyscall3( int, open, const char *, pathname, int, flags, mode_t, mode )
static inline _sfsyscall1( int, close, int, fd )
// wait4
static inline _sfsyscall2( int, link, const char *, oldpath, const char *, newpath )
static inline _sfsyscall1( int, unlink, const char *, pathname )
static inline _sfsyscall1( int, chdir, const char *, path )
// fchdir
static inline _sfsyscall3( int, mknod, const char *, pathname, mode_t, mode, dev_t, dev )
static inline _sfsyscall2( int, chmod, const char *, path, mode_t, mode )
static inline _sfsyscall3( int, chown, const char *, path, uid_t, owner, gid_t, group )
// getfsstat
static inline _sfsyscall0( pid_t, getpid )
// setuid
static inline _sfsyscall0( uid_t, getuid )
static inline _sfsyscall0( uid_t, geteuid )
static inline _sfsyscall4(long, ptrace, int, request, pid_t, pid, void *,addr, void *,data)
// recvmsg
// sendmsg
// recvfrom
static inline _sfsyscall3(int, accept, int,s, struct sockaddr *,addr, socklen_t,*addrlen);
// getpeername
// getsockname
static inline _sfsyscall2( int, access, const char *, pathname, int, mode )
// chflags
// fchflags
static inline _sfsyscall0( int, sync )
static inline _sfsyscall2( int, kill, pid_t, pid, int, sig )
static inline _sfsyscall0( pid_t, getppid )
static inline _sfsyscall1( int, dup, int, oldfd )
static inline _sfsyscall1( int, pipe, unsigned long *, filedes)
static inline _sfsyscall0( gid_t, getegid )
// profil
// ktrace
// sigaction
static inline _sfsyscall0( gid_t, getgid )
// sigprocmask
// getlogin
// setlogin
static inline _sfsyscall1( int, acct, const char *, filename )
static inline _sfsyscall1( int, sigpending, sigset_t *, set )
// sigaltstack
static inline _sfsyscall4(int, ioctl, int,d, int,request, char *,argp, int,len)
// reboot
// revoke
static inline _sfsyscall2( int, symlink, const char *, oldpath, const char *, newpath )
static inline _sfsyscall3( int, readlink, const char *, path, char *, buf, size_t, bufsiz )
static inline _sfsyscall3(int, execve, char *, s, char **, argv, char **,envp)
static inline _sfsyscall1( mode_t, umask, mode_t, mask )
static inline _sfsyscall1( int, chroot, const char *, path )
static inline _sfsyscall3( int, msync, const void *, start, size_t, length, int, flags )
static inline _sfsyscall0( pid_t, vfork )
// sbrk
// sstk
static inline _sfsyscall2( int, munmap, void *, start, size_t, length )
static inline _sfsyscall3( int, mprotect, const void *, addr, size_t, len, int, prot )
// madvise
// mincore
// getgroups
static inline _sfsyscall2( int, setgroups, size_t, size, const gid_t *, list )
static inline _sfsyscall0( pid_t, getpgrp )
static inline _sfsyscall2( int, setpgid, pid_t, pid, pid_t, pgid )
// setitimer
static inline _sfsyscall2( int, swapon, const char *, path, int, swapflags )
// getitimer
// getdtablesize
static inline _sfsyscall2( int, dup2, int, oldfd, int, newfd )
static inline _sfsyscall3( int, fcntl, int, fd, int, cmd, long, arg )
static inline _sfsyscall5( int, select, int,  n, fd_set *, readfds, fd_set *, writefds, fd_set *, exceptfds, struct timeval *, timeout)
static inline _sfsyscall1( int, fsync, int, fd )
static inline _sfsyscall3( int, setpriority, int, which, int, who, int, prio )
static inline _sfsyscall3(int, socket, int,domain, int,type, int,protocol)
static inline _sfsyscall3(int,connect, int,sockfd, const struct sockaddr *,serv_addr, socklen_t,addrlen)
static inline _sfsyscall2( int, getpriority, int, which, int, who )
static inline _sfsyscall1( int, sigreturn, unsigned long, __unused )
static inline _sfsyscall3(int, bind, int,sockfd, struct sockaddr *,my_addr, socklen_t,addrlen)
// setsockopt
static inline _sfsyscall2(int,listen,int,s, int,backlog)
static inline _sfsyscall1( int, sigsuspend, const sigset_t *, mask )
static inline _sfsyscall2( int, gettimeofday, struct timeval *, tv, struct timezone *, tz )
// getrusage
// getsockopt
static inline _sfsyscall3( int, readv, int, fd, const struct iovec *, vector, int, count )
static inline _sfsyscall3( int, writev, int, fd, const struct iovec *, vector, int, count )
// settimeofday
static inline _sfsyscall3( int, fchown, int, fd, uid_t, owner, gid_t, group )
static inline _sfsyscall2( int, fchmod, int, fildes, mode_t, mode )
static inline _sfsyscall2( int, rename, const char *, oldpath, const char *, newpath )
// flock
// mkfifo
// sendto
// shutdown
// socketpair
static inline _sfsyscall2( int, mkdir, const char *, pathname, mode_t, mode )
static inline _sfsyscall1( int, rmdir, const char *, pathname )
// utimes
// futimes
// adjtime
static inline _sfsyscall0( pid_t, setsid )
static inline _sfsyscall1( pid_t, getpgid, pid_t, pid )
// setprivexec
static inline _sfsyscall4( ssize_t, pread, int, fd, void *, buf, size_t, count, off_t, offset )
// pwrite
// nfssvc
static inline _sfsyscall2( int, statfs, const char *, path, struct statfs *, buf )
static inline _sfsyscall2( int, fstatfs, int, fd, struct statfs *, buf )
// unmount
// getfh
// quotactl
// mount
// table
// gc_control
// add_profil
// kdebug_trace
// setgid
// setegid
// seteuid
// sigreturn_ppc
static inline _sfsyscall2( int, stat, const char *, file_name, struct stat *, buf )
static inline _sfsyscall2( int, fstat, int, filedes, struct stat *, buf )
static inline _sfsyscall2( int, lstat, const char *, file_name, struct stat *, buf )
// pathconf
// fpathconf
// getfsstat
// getrlimit
// setrlimit
// getdirentries
static inline _sfsyscall6(void *,mmap, void *,start, size_t,length, int,prot , int,flags, int,fd, off_t,offset)
static inline _sfsyscall3( off_t, lseek, int, fildes, off_t, offset, int, whence )
static inline _sfsyscall2( int, truncate, const char *, path, off_t, length )
static inline _sfsyscall2( int, ftruncate, int, fd, off_t, length )
static inline _sfsyscall2( int, mlock, const void *, addr, size_t, len )
static inline _sfsyscall2( int, munlock, const void *, addr, size_t, len )
// undelete
// kqueue_from_portset_np
// kqueue_portset_np
// mkcomplex
// statv
// lstatv
// fstatv
// getattrlist
// setattrlist
// getdirentriesattr
// exchangedata
// checkuseraccess
// searchfs
// fsctl
// nfsclnt
// fhopen
// minherit
// semsys
// msgsys
// shmsys
// semctl
// semget
// semop
// semconfig
// msgctl
// msgget
// msgsnd
// msgrcv
// shmat
// shmctl
// shmdt
// shmget
// shm_open
// shm_unlink
// sem_open
// sem_close
// sem_unlink
// sem_wait
// sem_trywait
// sem_post
// sem_getvalue
// sem_init
// sem_destroy
// load_shared_file
// reset_shared_file
// new_system_shared_regions
static inline _sfsyscall1( pid_t, getsid, pid_t, pid )
// aio_fsync
// aio_return
// aio_suspend
// aio_cancel
// aio_error
// aio_read
// aio_write
// lio_listio
static inline _sfsyscall1( int, mlockall, int, flags )
static inline _sfsyscall0( int, munlockall )
// issetugid
// pthread_sigmask
// sigwait
// audit
// auditon
// auditsvc
// getauid
// setauid
// getaudit
// setaudit
// getaudit_addr
// setaudit_addr
// auditctl
// kqueue
// kevent

#endif /* SFLIB_H */
