/*
 * sflib.h --- SFLib syscall library for Solaris/Sparc 
 * see http://www.secdev.org/projects/shellforge.html for more informations
 *
 * Copyright (C) 2004  Philippe Biondi <phil@secdev.org>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */


/*
 * Automatically generated by gensflib.py 
 * Sun Dec  5 01:07:50 2004
 */

#ifndef SFLIB_H
#define SFLIB_H

#define SF_BIGENDIAN


#include "sfsysnr.h"
#include "sfsyscall.h"
#include "../common/sftypes.h"
        

// syscall
static inline _sfsyscall1(int, exit, int, status)
static inline _sfsyscall0( pid_t, fork )
static inline _sfsyscall3( ssize_t, read, int, fd, void *, buf, size_t, count )
static inline _sfsyscall3( ssize_t, write, int, fd, const void *, buf, size_t, count )
static inline _sfsyscall3( int, open, const char *, pathname, int, flags, mode_t, mode )
static inline _sfsyscall1( int, close, int, fd )
// wait
static inline _sfsyscall2( int, creat, const char *, pathname, mode_t, mode )
static inline _sfsyscall2( int, link, const char *, oldpath, const char *, newpath )
static inline _sfsyscall1( int, unlink, const char *, pathname )
// exec
static inline _sfsyscall1( int, chdir, const char *, path )
static inline _sfsyscall1( time_t, time, time_t *, t )
static inline _sfsyscall3( int, mknod, const char *, pathname, mode_t, mode, dev_t, dev )
static inline _sfsyscall2( int, chmod, const char *, path, mode_t, mode )
static inline _sfsyscall3( int, chown, const char *, path, uid_t, owner, gid_t, group )
static inline _sfsyscall1( int, brk, void *, end_data_segment )
static inline _sfsyscall2( int, stat, const char *, file_name, struct stat *, buf )
static inline _sfsyscall3( off_t, lseek, int, fildes, off_t, offset, int, whence )
static inline _sfsyscall0( pid_t, getpid )
// mount
static inline _sfsyscall1( int, umount, const char *, dir )
// setuid
static inline _sfsyscall0( uid_t, getuid )
static inline _sfsyscall1( int, stime, time_t *, t )
// pcsample
static inline _sfsyscall1( unsigned int, alarm, unsigned int, seconds )
static inline _sfsyscall2( int, fstat, int, filedes, struct stat *, buf )
static inline _sfsyscall0( int, pause )
static inline _sfsyscall2( int, utime, const char *, filename, struct utimbuf *, buf )
// stty
// gtty
static inline _sfsyscall2( int, access, const char *, pathname, int, mode )
static inline _sfsyscall1( int, nice, int, inc )
static inline _sfsyscall2( int, statfs, const char *, path, struct statfs *, buf )
static inline _sfsyscall0( int, sync )
static inline _sfsyscall2( int, kill, pid_t, pid, int, sig )
static inline _sfsyscall2( int, fstatfs, int, fd, struct statfs *, buf )
// pgrpsys
// xenix
static inline _sfsyscall1( int, dup, int, oldfd )
static inline _sfsyscall1( int, pipe, unsigned long *, filedes)
static inline _sfsyscall1( clock_t, times, struct tms *, buf )
// profil
// plock
// setgid
static inline _sfsyscall0( gid_t, getgid )
static inline _sfsyscall2( sighandler_t, signal, int, signum, sighandler_t, handler )
// msgsys
// syssun
// sysi86
static inline _sfsyscall1( int, acct, const char *, filename )
// shmsys
// semsys
static inline _sfsyscall4(int, ioctl, int,d, int,request, char *,argp, int,len)
// uadmin
// utssys
// fdsync
static inline _sfsyscall3(int, execve, char *, s, char **, argv, char **,envp)
static inline _sfsyscall1( mode_t, umask, mode_t, mask )
static inline _sfsyscall1( int, chroot, const char *, path )
static inline _sfsyscall3( int, fcntl, int, fd, int, cmd, long, arg )
// ulimit
// reserved_70
// reserved_71
// reserved_72
// reserved_73
// reserved_74
// reserved_75
// reserved_76
// reserved_77
// reserved_78
static inline _sfsyscall1( int, rmdir, const char *, pathname )
static inline _sfsyscall2( int, mkdir, const char *, pathname, mode_t, mode )
static inline _sfsyscall3( int, getdents, unsigned int, fd, struct dirent *, dirp, unsigned int, count )
static inline _sfsyscall3( int, sysfs, int, option, unsigned int, fs_index, char *, buf )
// getmsg
// putmsg
static inline _sfsyscall3( int, poll, struct pollfd *, ufds, unsigned int, nfds, int, timeout )
static inline _sfsyscall2( int, lstat, const char *, file_name, struct stat *, buf )
static inline _sfsyscall2( int, symlink, const char *, oldpath, const char *, newpath )
static inline _sfsyscall3( int, readlink, const char *, path, char *, buf, size_t, bufsiz )
static inline _sfsyscall2( int, setgroups, size_t, size, const gid_t *, list )
// getgroups
static inline _sfsyscall2( int, fchmod, int, fildes, mode_t, mode )
static inline _sfsyscall3( int, fchown, int, fd, uid_t, owner, gid_t, group )
// sigprocmask
static inline _sfsyscall1( int, sigsuspend, const sigset_t *, mask )
// sigaltstack
// sigaction
static inline _sfsyscall1( int, sigpending, sigset_t *, set )
// context
// evsys
// evtrapret
// statvfs
// fstatvfs
// getloadavg
// nfssys
// waitsys
// sigsendsys
// hrtsys
// acancel
// async
// priocntlsys
// pathconf
// mincore
static inline _sfsyscall6(void *,mmap, void *,start, size_t,length, int,prot , int,flags, int,fd, off_t,offset)
static inline _sfsyscall3( int, mprotect, const void *, addr, size_t, len, int, prot )
static inline _sfsyscall2( int, munmap, void *, start, size_t, length )
// fpathconf
static inline _sfsyscall0( pid_t, vfork )
// fchdir
static inline _sfsyscall3( int, readv, int, fd, const struct iovec *, vector, int, count )
static inline _sfsyscall3( int, writev, int, fd, const struct iovec *, vector, int, count )
// xstat
// lxstat
// fxstat
// xmknod
// clocal
// setrlimit
// getrlimit
static inline _sfsyscall3( int, lchown, const char *, path, uid_t, owner, gid_t, group )
// memcntl
// getpmsg
// putpmsg
static inline _sfsyscall2( int, rename, const char *, oldpath, const char *, newpath )
static inline _sfsyscall1( int, uname, struct utsname *, buf )
// setegid
// sysconfig
// adjtime
// systeminfo
// seteuid
// vtrace
// fork1
// sigtimedwait
// lwp_info
// yield
// lwp_sema_wait
// lwp_sema_post
// lwp_sema_trywait
// corectl
// modctl
// fchroot
// utimes
static inline _sfsyscall0( int, vhangup )
static inline _sfsyscall2( int, gettimeofday, struct timeval *, tv, struct timezone *, tz )
// getitimer
// setitimer
// lwp_create
// lwp_exit
// lwp_suspend
// lwp_continue
// lwp_kill
// lwp_self
// lwp_setprivate
// lwp_getprivate
// lwp_wait
// lwp_mutex_wakeup
// lwp_mutex_lock
// lwp_cond_wait
// lwp_cond_signal
// lwp_cond_broadcast
static inline _sfsyscall4( ssize_t, pread, int, fd, void *, buf, size_t, count, off_t, offset )
// pwrite
// llseek
// inst_sync
// srmlimitsys
// kaio
// cpc
// tsolsys
// acl
// auditsys
// processor_bind
// processor_info
// p_online
// sigqueue
// clock_gettime
// clock_settime
// clock_getres
// timer_create
// timer_delete
// timer_settime
// timer_gettime
// timer_getoverrun
static inline _sfsyscall2( int, nanosleep, const struct timespec *, req, struct timespec *, rem )
// facl
// door
static inline _sfsyscall2( int, setreuid, uid_t, ruid, uid_t, euid )
static inline _sfsyscall2( int, setregid, gid_t, rgid, gid_t, egid )
// install_utrap
// signotify
// schedctl
// pset
// sparc_utrap_install
// resolvepath
// signotifywait
// lwp_sigredirect
// lwp_alarm
// getdents64
// mmap64
// stat64
// lstat64
// fstat64
// statvfs64
// fstatvfs64
// setrlimit64
// getrlimit64
// pread64
// pwrite64
// creat64
// open64
// rpcsys
// so_socket
// so_socketpair
static inline _sfsyscall3(int, bind, int,sockfd, struct sockaddr *,my_addr, socklen_t,addrlen)
static inline _sfsyscall2(int,listen,int,s, int,backlog)
static inline _sfsyscall3(int, accept, int,s, struct sockaddr *,addr, socklen_t,*addrlen);
static inline _sfsyscall3(int,connect, int,sockfd, const struct sockaddr *,serv_addr, socklen_t,addrlen)
// shutdown
// recv
// recvfrom
// recvmsg
static inline _sfsyscall4(int,send,  int,s, const void *,msg, size_t,len, int,flags);
// sendmsg
// sendto
// getpeername
// getsockname
// getsockopt
// setsockopt
// sockconfig
// ntp_gettime
// ntp_adjtime
// lwp_mutex_unlock
// lwp_mutex_trylock
// lwp_mutex_init
// cladm
// lwp_sigtimedwait
// umount2



#endif /* SFLIB_H */
